﻿using System.Linq;
using System.Windows.Forms;

namespace AutoFillFormCS
{
    public static class modExtensions
    {

        public static void Fill(this Form frm, object obj)
        {
            var textBoxes = frm.Controls.OfType<TextBox>();
            var properties = obj.GetType().GetProperties();

            foreach (var tb in textBoxes)
            {
                var wrongPrefix = !tb.Name.StartsWith("tb");
                if (wrongPrefix)
                    continue;

                var nameWithoutPrefix = tb.Name.Substring(2);
                var matchingProperty = properties.SingleOrDefault(x => x.Name == nameWithoutPrefix);
                if (matchingProperty == null || matchingProperty.PropertyType != typeof(string))
                    continue;

                tb.Text = matchingProperty.GetValue(obj).ToString();
            }
        }

    }
}
